<template>
  <div class="flex flex-col items-start pb-5 w-full">
    <p>{{ label }}</p>
    <label
      class="border-2 border-blue-400 transition rounded p-2 focus-within:border-rose-300 w-full"
    >
      <textarea class="resize-none w-full bg-transparent" :value="modelValue" @blur="blurInput" @input="update" />
    </label>
    <transition name="nav-menu">
      <span
        v-if="error"
        class="absolute top-[calc(100%+4px)] text-sm text-red-600"
      >
        <slot name="error" />
      </span>
    </transition>
  </div>
</template>

<script setup lang="ts">
defineProps({
  modelValue: {
    type: [String, Number],
    default: "",
  },
  label: {
    type: String,
    default: "label",
  },
  error: {
    type: String,
    default: "",
  },
});
const $emit = defineEmits(["update:modelValue", "input", "blur"]);
const update = (e: Event) => {
  $emit("update:modelValue", (e.target as HTMLInputElement).value);
  $emit("input", (e.target as HTMLInputElement).value);
};

const blurInput = (e: Event) => {
  $emit("blur", (e.target as HTMLInputElement).value);
};
</script>
